import java.awt.*;
import javax.swing.*;

class AWTComponents extends Panel
{
  public AWTComponents()
  {
    new BoxLayout(this, BoxLayout.Y_AXIS);

    Box b1 = new Box(BoxLayout.Y_AXIS);

    b1.add(new Button("Button"));
    CheckboxGroup cbg = new CheckboxGroup();
    Checkbox cb1 = new Checkbox("First Checkbox", true, cbg);
    Checkbox cb2 = new Checkbox("Second Checkbox", false, cbg);
    b1.add(cb1);
    b1.add(cb2);
    
    Box b2 = new Box(BoxLayout.Y_AXIS);
    b2.add(new Label("Text field"));
    b2.add(new TextField("Text fields can contain only a single line of text."));
    b2.add(new Label("Text area"));
    String text = "A text field can contain only one line of \ntext, but a text area can contain multiple lines \nof text.  Here is an example.  ";
    b2.add(new TextArea(text, 3, 40));
    add(b1);

    Box b3 = new Box(BoxLayout.Y_AXIS);

    List l = new List(7);
    l.add("Balzac");
    l.add("Cervantes");
    l.add("Hawthorne");
    l.add("Pushkin");
    l.add("Steinbeck");
    l.add("Tolstoy");
    l.add("Zola");
    l.add("Keates");
    l.add("Whitman");

    b3.add(new Label("List component - a list of selectable items"));
    b3.add(l);

    Choice ch = new Choice();
    ch.add("She loves me.");
    ch.add("She loves me not.");
    ch.add("She can't decide.");
    ch.add("I can't decide either.");
    b3.add(new Label("Choice component - a drop-down list of choices"));
    b3.add(ch);

    Box b4 = new Box(BoxLayout.X_AXIS);
    Scrollbar sb1 = new Scrollbar(Scrollbar.HORIZONTAL);
    Scrollbar sb2 = new Scrollbar(Scrollbar.VERTICAL);
    sb1.setValues(100, 20, 10, 40);
    sb1.setVisibleAmount(30);
    sb2.setVisibleAmount(20);
    b4.add(sb1);
    b4.add(sb2);

    add(b1);
    add(b2);
    add(b3);
    add(b4);

  }
  
  public Dimension getPreferredSize()
  {
    return new Dimension(400, 700);
  }

  public static void main(String [] args)
  {
    AWTComponents app = new AWTComponents();
    Frame f = new Frame();
    f.setTitle("AWT Components");
    f.add(app);
    f.pack();
    f.setVisible(true);
  }

}
