import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Panel;

/**
   Defines simple frame objects with no child components.
   This class subclasses java.awt.Frame and is therefore a
   type of frame.
*/
class FrameOnly extends Frame
{
  /**
     No-arg constructor.
  */
  public FrameOnly()
  {
    super("An empty frame");
  }

  /**
     Specifies the preferred size of the component.

     @return the preferred size as a Dimension object.
  */
  public Dimension getPreferredSize()
  {
    return new Dimension(300, 300);
  }


  /**
     Main function.  Creates an instance of the application,
     which is already the frame necessary for display on the
     screen.  Calculates the required minimum size of the
     frame, and displays it.
  */
  public static void main(String [] args)
  {
    FrameOnly f = new FrameOnly();
    f.pack();
    f.setVisible(true);
  }


}
