import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.Panel;

/**
   This class defines a panel that does not contain any
   children.  Instances of this class need to be placed in a
   separately created frame object in order to be displayed
   on screen.
 */
class PanelOnly extends Panel
{
  /**
     No-arg constructor.
  */
  public PanelOnly()
  {
    super();
  }


  /**
     Specifies the preferred size of the component.

     @return the preferred size as a Dimension object.
  */
  public Dimension getPreferredSize()
  {
    return new Dimension(300, 300);
  }


  /**
     Creates an instance of this class.  Also creates the
     frame that must contain the instance.  Packs the frame
     and displays it.
  */     
  public static void main(String [] args)
  {
    PanelOnly app = new PanelOnly();

    Frame f = new Frame("An empty panel in a frame");
    f.add(app);
    f.pack();
    f.setVisible(true);
  }
}
