import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Label;
import java.awt.List;
import java.awt.Panel;
import java.awt.TextField;

/**
   This class demonstrates how to add a component to a
   component to a container.  
*/
class MultipleComponents extends Frame
{
  /**
     No-arg constructor.  Builds the container and places
     several components in it.
  */
  public MultipleComponents()
  {
    super("A frame with some components");
    setLayout(new FlowLayout());

    Font font14 = new Font("SansSerif", Font.PLAIN, 14);
    Font font18 = new Font("SansSerif", Font.PLAIN, 18);

    // A Label component.
    label = new Label("A simple label in a frame");
    label.setFont(font18);

    // A Button component.
    button = new Button("Push me");
    button.setFont(font14);

    // A TextField component.
    textField = new TextField("A text field");
    textField.setFont(font14);

    // A List component.  Create a list object and populate
    // it with string items.
    //
    list = new List(7);
    list.setFont(font14);
    list.add("Button");
    list.add("Canvas");
    list.add("Checkbox");
    list.add("Label");
    list.add("List");
    list.add("Scrollbar");
    list.add("ScrollPane");
    list.add("TextField");
    list.add("TextArea");

    // Add the four components created above to the container.
    //
    add(label);
    add(button);
    add(textField);
    add(list);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(300, 300);
  }

  public static void main(String [] args)
  {
    MultipleComponents f = new MultipleComponents();
    f.pack();
    f.setVisible(true);
  }

  Button button;
  TextField textField;
  Label label;
  List list;
  
}
