import java.awt.Button;
import java.awt.Component;
import java.awt.Font;
import java.awt.Frame;
import java.awt.Panel;

/**
   A class that displays three buttons, each one
   demonstrating a different state supported by Buttons.
*/
public class Buttons extends Panel
{
  /**
     No-arg constructor. Builds the entire visible GUI before 
     it returns.  
  */
  public Buttons()
  {
    Font f18 = new Font("SansSerif", Font.PLAIN, 18);

    Button b1 = new Button("Enabled button");
    Button b2 = new Button("Disabled button");

    Button b3 = new Button();
    b3.setLabel("Depressed button");

    b1.setFont(f18);

    // The second button is initially disabled.  It cannot
    // respond to events.
    //
    b2.setFont(f18);
    b2.setEnabled(false);

    b3.setFont(f18);

    add(b1);
    add(b2);
    add(b3);
  }

  public static void main(String [] args)
  {
    Buttons app = new Buttons();

    Frame f = new Frame("Buttons");
    f.add(app);
    f.pack();
    f.setVisible(true);
  }
}
