import java.awt.Font;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.GridBagLayout;
import java.awt.GridBagConstraints;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;

/**
   A class that builds a panel of various text components.
   Demonstrates use of the AWT TextField and TextArea
   classes.
*/
public class Text extends Panel
{
  /**
     No-arg constructor.
  */
  public Text()
  {
    Font f18 = new Font("SansSerif", Font.PLAIN, 18);
    Font f14 = new Font("SansSerif", Font.PLAIN, 14);

    setLayout(new GridLayout(0, 1));

    GridBagLayout gbl = new GridBagLayout();
    GridBagConstraints gbc = new GridBagConstraints();

    // A nested panel to hold the address fields.
    //
    Panel addressPanel = new Panel();
    addressPanel.setLayout(gbl);

    gbc.anchor = GridBagConstraints.EAST;

    Label name = new Label("Name :  ");
    name.setFont(f14);
    gbl.setConstraints(name, gbc);

    gbc.gridx = 0;
    gbc.gridy = GridBagConstraints.RELATIVE;

    Label address = new Label("Address :  ");
    address.setFont(f14);
    gbl.setConstraints(address, gbc);

    Label city = new Label("City/State/Zip :  ");
    city.setFont(f14);
    gbl.setConstraints(city, gbc);

    Label phone = new Label("Phone :  ");
    phone.setFont(f14);
    gbl.setConstraints(phone, gbc);

    addressPanel.add(name);
    addressPanel.add(address);
    addressPanel.add(city);
    addressPanel.add(phone);

    gbc.gridx = 1;
    gbc.anchor = GridBagConstraints.WEST;

    // This text field is not editable because the editable
    // attribute is set to "false".  This field will appear
    // with a gray background instead of the white
    // background for editable fields.
    //
    TextField nameVal = new TextField("Confucious");
    nameVal.setFont(f14);
    nameVal.setEditable(false);
    gbl.setConstraints(nameVal, gbc);

    TextField addVal = new TextField("Kong miao");
    addVal.setFont(f14);
    gbl.setConstraints(addVal, gbc);

    TextField cityVal = new 
      TextField("Shan dong, Shan dong Province, China");
    cityVal.setFont(f14);
    cityVal.select(3, 9);
    gbl.setConstraints(cityVal, gbc);

    TextField phoneVal = new TextField("011 86 56 33 23 54 91");
    phoneVal.setFont(f14);
    gbl.setConstraints(phoneVal, gbc);

    addressPanel.add(nameVal);
    addressPanel.add(addVal);
    addressPanel.add(cityVal);
    addressPanel.add(phoneVal);

    add(addressPanel);

    // Another nested panel to hold the "Favorite proverb"
    // label and proverb text area.
    //
    Panel bioPanel = new Panel();
    bioPanel.setLayout(gbl);

    gbc.gridx = 0;
    Label favorite = new Label("Favorite proverb:");
    favorite.setFont(f14);
    gbl.setConstraints(favorite, gbc);
    bioPanel.add(favorite);

    // Create the text for the text area.  Notice the line
    // feed must be inserted in the text, or the text will
    // be all on one line.  The text area would then have to
    // be scrolled horizontally to read all the text.
    //
    StringBuffer text = new StringBuffer();
    text.append("Better for one to remain silent ");
    text.append("and be thought a fool,\n");
    text.append("then to open one's mouth ");
    text.append("and remove all doubt.");

    TextArea proverb = new TextArea();
    proverb.setText(text.toString());

    gbl.setConstraints(proverb, gbc);
    gbc.gridheight = 3;
    bioPanel.add(proverb);

    add(bioPanel);
  }

  public static void main(String [] args)
  {
    Text app = new Text();

    Frame f = new Frame("Text Components");
    f.add(app);
    f.pack();
    f.setVisible(true);
  }
}
