import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates the use of Swing check boxes.
*/
public class CheckBoxes extends JPanel
{
  /**
     No-arg constructor.
  */
  public CheckBoxes()
  {
    // A disabled checkbox. 
    //
    JCheckBox cb1 = new JCheckBox("Carbohydrate");
    cb1.setMnemonic('C');
    cb1.setEnabled(false);

    // An enabled checkbox.  The text for these first four checkboxes
    // is placed to the right of the actual square check box.
    //
    JCheckBox cb2 = new JCheckBox("Fat");
    cb2.setMnemonic('F');
    cb2.setRolloverEnabled(true);

    JCheckBox cb3 = new JCheckBox("Protein");
    cb3.setMnemonic('P');
    cb3.setFocusPainted(true);

    JCheckBox cb4 = new JCheckBox("Starch");
    cb4.setVerticalTextPosition(AbstractButton.TOP);
    cb4.setMnemonic('S');

    // Create the panel for the above checkboxes.  This is the
    // left-hand column of checkboxes.
    //
    JPanel chem = new JPanel();
    chem.setLayout(new GridLayout(0, 1));
    chem.add(cb1);
    chem.add(cb2);
    chem.add(cb3);
    chem.add(cb4);

    // A checkbox with the text to the left of the square check box.
    //
    JCheckBox cb5 = new JCheckBox("Dairy");
    cb5.setHorizontalTextPosition(AbstractButton.LEFT);
    cb5.setMnemonic('D');

    // Notice the mnemonic keys are the same as one letter in the
    // checkbox text.
    //
    JCheckBox cb6 = new JCheckBox("Poultry");
    cb6.setMnemonic('l');

    JCheckBox cb7 = new JCheckBox("Meat");
    cb7.setMnemonic('M');

    JCheckBox cb8 = new JCheckBox("Vegetables");
    cb8.setMnemonic('V');

    // Create the panel for the second column of checkboxes.  These
    // appear to the right of the first column.
    //
    JPanel foodGroups = new JPanel();
    foodGroups.setLayout(new GridLayout(0, 1));
    foodGroups.add(cb5);
    foodGroups.add(cb6);
    foodGroups.add(cb7);
    foodGroups.add(cb8);

    add(chem);
    add(foodGroups);

  }

  public static void main(String [] args)
  {
    CheckBoxes app = new CheckBoxes();

    JFrame f = new JFrame("JCheckBox Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

}
