import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;

import javax.swing.*;

/**
   This class demonstrates the use of Swing editor panes. Editor panes
   can display either regular text, HTML, or Rich Text Format text.
   Any given instance can display only one of these kinds of text
   however.
*/
class EditorPaneDemo extends JPanel
{
  /**
     No-arg constructor.
  */
  public EditorPaneDemo()
  {
    // Create an editor pane and place it in a scroll pane.
    //
    JEditorPane editorPane = new JEditorPane();
    JScrollPane scrollPane = new JScrollPane(editorPane);
    scrollPane.setPreferredSize(new Dimension(450, 350));
    scrollPane.setVerticalScrollBarPolicy(
        JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    scrollPane.setHorizontalScrollBarPolicy(
        JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);

    // Don't allow editing of the content.
    //
    editorPane.setEditable(false);

    // This editor pane will display HTML.  Set the editor pane's page
    // to the contents of the specified HTML file.
    //
    try 
      {
	URL url = new 
	  URL("file:/home/vartan/dev/book/ch7/editor-pane-demo.html");
	editorPane.setPage(url);
      }
    catch (Exception e)
      {

      }

    Box box = Box.createVerticalBox();
    box.add(scrollPane);
    add(box);
  }

  public static void main(String [] args)
  {
    JFrame f = new JFrame("Editor Pane Demo");

    EditorPaneDemo app = new EditorPaneDemo();
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
