import java.awt.*;
import java.awt.event.*;
import javax.swing.*;

/**
   This class demonstrates use of Swing sliders. 
*/
class Sliders extends JPanel
{
  /**
     No-arg constructor.
  */
  public Sliders()
  {
    JLabel msg = new JLabel("Set your ideal temperature (Celsius)");
    
    // Create a horizontally-oriented slider that shows Celsius
    // temperatures.
    //
    JSlider horizSlider = new JSlider();

    // Set the minimum, maximum scale values displayed, and the initial
    // value (my favorite Celsius temperature).
    //
    horizSlider.setMinimum(-20);
    horizSlider.setMaximum(50);
    horizSlider.setValue(27);

    // Set the resolution of the major and minor tick marks.  You also
    // have to explicitly request that tick marks be displayed, even
    // if you set the resolution for the major and minor tick spacing.
    //
    horizSlider.setPaintTicks(true);
    horizSlider.setPaintLabels(true);
    horizSlider.setMajorTickSpacing(10);
    horizSlider.setMinorTickSpacing(1);
    horizSlider.setPreferredSize(new Dimension(350, 60));

    // Create a vertically-oriented slider.  Do all the same
    // intializations.  This one shows Fahrenheit temperatures.
    //
    JSlider vertSlider = new JSlider(JSlider.VERTICAL, -30, 120, 72);
    vertSlider.setPaintTicks(true);
    vertSlider.setPaintLabels(true);
    vertSlider.setMajorTickSpacing(10);
    vertSlider.setMinorTickSpacing(5);
    vertSlider.setPreferredSize(new Dimension(60, 300));

    Box box = Box.createVerticalBox();

    box.add(horizSlider);
    box.add(vertSlider);

    add(box);
  }


  public static void main(String [] args)
  {
    JFrame f = new JFrame("Sliders Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    ((Window) e.getSource()).dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    Sliders app = new Sliders();

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}
