import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.URL;

import javax.swing.*;
import javax.swing.event.*;

class HyperlinkEventDemo extends JPanel
{

  public HyperlinkEventDemo()
  {
    JEditorPane editorPane = new JEditorPane();
    JScrollPane scrollPane = new JScrollPane(editorPane);
    scrollPane.setPreferredSize(new Dimension(400, 485));
    scrollPane.setVerticalScrollBarPolicy(JScrollPane.VERTICAL_SCROLLBAR_ALWAYS);
    scrollPane.setHorizontalScrollBarPolicy(JScrollPane.HORIZONTAL_SCROLLBAR_ALWAYS);
    editorPane.setEditable(false);

    // Add a HyperlinkListener to the JEditorPane.
    //
    HyperlinkListener hyperlinkEventMonitor = new
      HyperlinkEventMonitor();

    editorPane.addHyperlinkListener(hyperlinkEventMonitor);

    try 
      {
	URL url = new 
	  URL("file:/home/vartan/dev/book/ch7/editor-pane-demo.html");
	editorPane.setPage(url);
      }
    catch (Exception e)
      {

      }

    Box box = Box.createVerticalBox();
    box.add(scrollPane);
    add(box);
  }

  public static void main(String [] args)
  {
    JFrame f = new JFrame("Hyperlink Event Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);

    HyperlinkEventDemo app = new HyperlinkEventDemo();
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }
}


class HyperlinkEventMonitor implements HyperlinkListener
{
  public void hyperlinkUpdate(HyperlinkEvent e)
  {
    System.out.println("HyperlinkEvent: ");
    System.out.println("Link description: " + e.getDescription());
    System.out.println("Event type: " + e.getEventType());
    System.out.println("URL: " + e.getDescription());
    System.out.println();
  }
}

