import java.awt.BorderLayout;
import java.awt.CardLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Image;
import java.awt.Window;

import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.awt.event.WindowListener;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JPanel;

import javax.swing.border.BevelBorder;

public class ImageGallery extends JPanel
{
  public ImageGallery()
  {
    super();
    create();
    loadImages();
  }


  protected void create()
  {
    first = new JButton("First");
    previous = new JButton("Previous");
    next = new JButton("Next");
    last = new JButton("Last");

    buttonPanel = new JPanel();

    buttonPanel.add(first);
    buttonPanel.add(previous);
    buttonPanel.add(next);
    buttonPanel.add(last);

    imagePanel = new JPanel();
    imagePanel.setBorder(BorderFactory.createBevelBorder(BevelBorder.LOWERED));
    imagePanel.setLayout(new CardLayout());

    setLayout(new BorderLayout());
    add(buttonPanel, BorderLayout.NORTH);
    add(imagePanel, BorderLayout.CENTER);

    ActionListener firstListener = new ActionListener() 
      {
	public void actionPerformed(ActionEvent e) 
	  {
	    CardLayout layout = (CardLayout) imagePanel.getLayout();
	    layout.first(imagePanel);
	  }
      };
    first.addActionListener(firstListener);


    ActionListener previousListener = new ActionListener() 
      {
	public void actionPerformed(ActionEvent e) 
	  {
	    CardLayout layout = (CardLayout) imagePanel.getLayout();
	    layout.previous(imagePanel);
	  }
      };
    previous.addActionListener(previousListener);

    ActionListener nextListener = new ActionListener() 
      {
	public void actionPerformed(ActionEvent e) 
	  {
	    CardLayout layout = (CardLayout) imagePanel.getLayout();
	    layout.next(imagePanel);
	  }
      };
    next.addActionListener(nextListener);

    ActionListener lastListener = new ActionListener() 
      {
	public void actionPerformed(ActionEvent e) 
	  {
	    CardLayout layout = (CardLayout) imagePanel.getLayout();
	    layout.last(imagePanel);
	  }
      };
    last.addActionListener(lastListener);

    first.addActionListener(firstListener);
    previous.addActionListener(previousListener);
    next.addActionListener(nextListener);
    last.addActionListener(lastListener);

    MouseListener mm = new MouseAdapter()
      {
	public void mouseClicked(MouseEvent e)
	  {
	    System.out.println(e.getSource().toString());
	  }
      };

    first.addMouseListener(mm);
    previous.addMouseListener(mm);
    next.addMouseListener(mm);
    last.addMouseListener(mm);
  }


  protected void loadImages()
  {
    images = new Image [NUM_IMAGES];

    imagePanel.add(new JButton(new ImageIcon("../images/alpine-lake.gif")),
		   "alpine-lake");
    imagePanel.add(new JButton(new ImageIcon("../images/beach1.gif")),
		   "beach1");
    imagePanel.add(new JButton(new ImageIcon("../images/buds.gif")),
		   "buds");
    imagePanel.add(new JButton(new ImageIcon("../images/golden-fish.gif")),
		   "golden-fish");
    imagePanel.add(new JButton(new ImageIcon("../images/morning-walk.gif")),
		   "morning-walk");
    imagePanel.add(new JButton(new ImageIcon("../images/observatory.gif")),
		   "observatory");
    imagePanel.add(new JButton(new ImageIcon("../images/open-gate.gif")),
		   "open-gate");
    imagePanel.add(new JButton(new ImageIcon("../images/pebble-beach.gif")),
		   "pebble-beach");
    imagePanel.add(new JButton(new ImageIcon("../images/tree-lined-path.gif")),
		   "tree-lined-path");
    imagePanel.add(new JButton(new ImageIcon("../images/stormy-pier.gif")),
		   "stormy-pier");
  }


  public void actionPerformed(ActionEvent e)
  {
    
  }


  public Dimension getPreferredSize()
  {
    return new Dimension(350, 400);
  }


  public Dimension getMinimumSize()
  {
    return getPreferredSize();
  }


  public static void main(String [] args)
  {
    ImageGallery app = new ImageGallery();

    JFrame f = new JFrame("Image Selector Demo");
    WindowListener wl = new WindowAdapter() 
      {
	public void windowClosing(WindowEvent e) 
	{
	  ((Window) e.getSource()).dispose();
	  System.exit(0);
	}
      };
    f.addWindowListener(wl);
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  static final int NUM_IMAGES = 10;

  private JButton first, next, previous, last;
  private JPanel buttonPanel;
  private JPanel imagePanel;

  Image [] images;
}

