import java.awt.*;
import java.awt.event.*;

import javax.swing.*;
import javax.swing.event.*;


public class ListDataEventDemo extends JPanel
{
  public ListDataEventDemo()
  {
    JPanel compPanel = createCompPanel();
    JPanel buttonPanel = createButtonPanel();

    ListDataListener ldl = new ListDataMonitor();

    defaultListModel = new DefaultListModel();
    defaultListModel.addListDataListener(ldl);
    defaultListModel.addListDataListener(comboBox);

    setLayout(new BorderLayout());
    add(buttonPanel, BorderLayout.NORTH);
    add(compPanel, BorderLayout.CENTER);
  }


  JPanel createCompPanel()
  {
    comboBox = new JComboBox();

    JPanel p = new JPanel();
    p.add(comboBox);
    
    return p;
  }


  JPanel createButtonPanel()
  {
    JButton addItem = createAddButton();
    JButton removeItem = createRemoveButton();

    JPanel p = new JPanel();
    p.add(addItem);
    p.add(removeItem);
    
    return p;
  }


  JButton createAddButton()
  {
    JButton b = new JButton("Add Item");

    ActionListener aL = new ActionListener()
      {
	public void actionPerformed(ActionEvent e)
	  {
	    String str = "Item number " + Integer.toString(lastValue++, 10);
	    defaultListModel.addElement(str);
	    comboBox.addItem(str);
	    comboBox.showPopup();
	  }
      };
    b.addActionListener(aL);

    return b;
  }


  JButton createRemoveButton()
  {
    JButton b = new JButton("Remove Item");

    ActionListener aL = new ActionListener()
      {
	public void actionPerformed(ActionEvent e)
	  {
	    defaultListModel.removeElementAt(--lastValue);
	    comboBox.removeItemAt(lastValue);
	    comboBox.showPopup();
	  }
      };
    b.addActionListener(aL);

    return b;
  }


  public Dimension getPreferredSize()
  {
    return new Dimension(350, 250);
  }


  public static void main(String [] args)
  {
    ListDataEventDemo app = new ListDataEventDemo();

    JFrame f = new JFrame("List Data Event Demo");
    WindowListener wL = new WindowAdapter()
      {
	public void windowClosing(WindowEvent e)
	  {
	    e.getWindow().dispose();
	    System.exit(0);
	  }
      };
    f.addWindowListener(wL);
    
    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  DefaultListModel defaultListModel;

  int lastValue;

  JComboBox comboBox;
}


class ListDataMonitor implements ListDataListener
{
  public void contentsChanged(ListDataEvent e)
  {
    System.out.println("Contents changed.");
    System.out.println("Index0 = " + e.getIndex0());
    System.out.println("Index1 = " + e.getIndex1());
    System.out.println();
  }

  public void intervalAdded(ListDataEvent e)
  {
    System.out.println("Adding interval:   Index0 = " + e.getIndex0());
    System.out.println("                   Index1 = " + e.getIndex1());
    System.out.println();
  }

  public void intervalRemoved(ListDataEvent e)
  {
    System.out.println("Removing interval: Index0 = " + e.getIndex0());
    System.out.println("                   Index1 = " + e.getIndex1());
    System.out.println();
  }
}

