import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;

public class WindowEventDemo extends JPanel 
{
  public WindowEventDemo()
  {
    setLayout(new BorderLayout());
    JLabel label = new JLabel("A simple window");
    label.setHorizontalAlignment(SwingConstants.CENTER);

    add(label, BorderLayout.CENTER);
  }

  public Dimension getPreferredSize()
  {
    return new Dimension(350, 200);
  }

  public static void main(String [] args)
  {
    WindowEventDemo app = new WindowEventDemo();

    JFrame f = new JFrame("Window Event Demo");

    WindowListener wl = new WindowMonitor() ;
    f.addWindowListener(wl);

    f.getContentPane().add(app);
    f.pack();
    f.setVisible(true);
  }

  JLabel label;
}



class WindowMonitor implements WindowListener
{
  public void windowActivated(WindowEvent e)
  {
    System.out.println("Window activated.");
  }

  public void windowClosed(WindowEvent e)
  {
    System.out.println("Window closed.");
    ((Window) e.getSource()).dispose();
    System.exit(0);
  }

  public void windowClosing(WindowEvent e)
  {
    System.out.println("Window closing.");
    ((Window) e.getSource()).dispose();
  }

  public void windowDeactivated(WindowEvent e)
  {
    System.out.println("Window deactivated.");

  }

  public void windowDeiconified(WindowEvent e)
  {
    System.out.println("Window deiconified.");

  }

  public void windowIconified(WindowEvent e)
  {
    System.out.println("Window iconified.");

  }

  public void windowOpened(WindowEvent e)
  {
    System.out.println("Window opened.");
  }
}
